#!/usr/local/bin/ruby 
print <<'EOQ'
/* this file is created by mksrc.rb (99/08/04 numa@ees.hokudai.ac.jp) */

#include <ruby.h>
#include <math.h>

struct MC_ARRAY {
    int type;        /* 0: int, 1: float */ 
    int dimension;   /* numbwer of dimension */
    int *size;       /* array size for each dimension */
    int total;       /* total size */
    union {
      int    *i;  /* body of the array; expressed as one-dimensitonal array */
      float  *f;  /* body of the array; expressed as one-dimensitonal array */
      double *d;  /* body of the array; expressed as one-dimensitonal array */
    } ptr;
};

#define MC_SetMCA(x,vx) \
        struct MC_ARRAY* x = (struct MC_ARRAY*)DATA_PTR(vx)

#define MC_SetInt(x,vx) \
        int   x = FIXNUM_P(vx) ? FIX2INT(vx) : (int)RFLOAT(vx)->value

#define MC_SetFloat(x,vx) \
        float x = FIXNUM_P(vx) ? (float)FIX2INT(vx) : (float)RFLOAT(vx)->value

#define MC_SetDouble(x,vx) \
        double x = FIXNUM_P(vx) ? (double)FIX2INT(vx) : RFLOAT(vx)->value

#define MC_SetString(x,vx) \
        char * x = STR2CSTR(vx)

#define MC_SetLogic(x,vx) \
        int x = FIXNUM_P(vx) ? (int)FIX2INT(vx) : \
           TYPE(vx)==T_FALSE || TYPE(vx)==T_NIL ? 0 : 1

#define MC_SetIntArray(x,vx) \
        int   * x = ((struct MC_ARRAY*)DATA_PTR(vx))->ptr.i

#define MC_SetFloatArray(x,vx) \
        float * x = ((struct MC_ARRAY*)DATA_PTR(vx))->ptr.f

#define MC_SetDoubleArray(x,vx) \
        float * x = ((struct MC_ARRAY*)DATA_PTR(vx))->ptr.d


#define MC_GetInt(x,vx) \
	vx = INT2FIX(x)

#define MC_GetFloat(x,vx) \
        vx = rb_float_new(x)

#define MC_GetDouble(x,vx) \
        vx = rb_float_new(x)

#define MC_GetString(x,vx) \
        vx = rb_str_new(x,strlen(x))

#define MC_GetLogic(x,vx) \
        vx = (x) ? Qtrue : Qfalse

#define MC_NewInt(x) \
	INT2FIX(x)

#define MC_NewFloat(x) \
	rb_float_new(x)

#define MC_NewDouble(x) \
	rb_float_new(x)

#define MC_NewChar(x) \
	rb_str_new(&x,1)

#define MC_NewString(x) \
	rb_str_new(x,strlen(x))

#define MC_NewLogic(x) \
	(x) ? Qtrue : Qfalse


EOQ

lnew=''
vary={}
typ=nil; ftyp=nil; name=nil; arg=nil; args=[]; lval={}
defs=[]; argn={}	

while gets
    $_.downcase!; $_.chop!
    next if /^c/ || /^\*/ || /^ *$/
#
#   continuing line
#
    l=lnew.dup;
    if ( $_[5] && $_[5] != ' '[0] ) 
       l += $_[6..$_.length-1]; next                     
    else
       lnew = $_;
    end
    l.gsub!(/ /,"")
#
#   subroutine, entry
#
    if (l=~/subroutine/ || l=~/entry/ || l=~/function/ || lnew=~/^ *end *$/)
#
#      do entry
#
#      DENNNOU
       if (name =~ /^..p(set|get|stx)/) then vary["ipara"]="integer" end
       if (name =~ /^..i(set|get|stx)/) then vary["ipara"]="integer" end
       if (name =~ /^..l(set|get|stx)/) then vary["ipara"]="logical" end
       if (name =~ /^..r(set|get|stx)/) then vary["ipara"]="real"    end
#
       if(typ) 
	  print "static VALUE\n"
	  if (arg) then
	    varg = ",#{arg}"
	    varg.gsub!(/,/,",V")
	    print "dcl_#{name}(self#{varg})\n"
	    print "    VALUE self#{varg};\n"
          else
	    print "dcl_#{name}(self)\n"
	    print "    VALUE self;\n"
          end
	  defs.push(name)
	  argn[name]=args.length
	  print "{\n";
	  rarg=""; larg="";
          args.each {|a|
	      if(!vary.key?(a)) 
                 if (a =~ /^[ijklmn]/) then vary[a]='integer'
                 else                       vary[a]='real'
                 end
              end
              let=nil
	      case vary[a]
                when "integer*"
		  rarg+= ",C#{a}"
	          let = "MC_SetIntArray(C#{a},V#{a});"
                when "real*"
		  rarg+= ",C#{a}"
	          let = "MC_SetFloatArray(C#{a},V#{a});"
	        when "character"
		  rarg+= ",C#{a}"
		  larg+= ",strlen(C#{a})"
                else
		  rarg+= ",&C#{a}"
              end
	      if(lval.key?(a)) then
  	        case vary[a]
                when "integer"
	          let = "int   C#{a};";
                when "real";         
	          let = "float C#{a};";
                when "real*8";       
	          let = "double C#{a};"; 
                when "logical";      
	          let = "int    C#{a};";
                when /character(\*.*)?/
	          let = "char * C#{a}=\"                \";";
               end
              else
  	        case vary[a]
                when "integer"
	          let = "MC_SetInt(C#{a},V#{a});"
                when "real"
	          let = "MC_SetFloat(C#{a},V#{a});"
                when /character(\*.*)?/
	          let = "MC_SetString(C#{a},V#{a});"
                when "logical"
	          let = "MC_SetLogic(C#{a},V#{a});"
                end
              end
              print "  #{let}\n" if let
          }
	  rarg.sub!(/^,/,'')
	  if(ftyp != "subroutine") 
              body = "ret = #{name}_(#{rarg}#{larg});"
              if (ftyp=="") then ftyp=vary[name]; end
	      case ftyp
              when "integer"
	        ret = "int ret;\n  int #{name}_();"
                retx = "MC_NewInt(ret);"
              when "real"
	        ret = "float ret;\n  float #{name}_();"
                retx = "MC_NewFloat(ret);" 
              when "real*8"
	        ret = "double ret;\n  double #{name}_();"
                retx = "MC_NewDouble(ret);"       
              when "character*1"
	        ret = "char ret;\n  char #{name}_();"
                retx = "MC_NewChar(ret);"
              when /character(\*.*)?/
	        ret = "char * ret;\n  char * #{name}_();"
                retx = "MC_NewString(ret);"
              when "logical"
	        ret = "int ret;\n  int #{name}_();"
                retx = "MC_NewLogic(ret);"
              end
              print "  #{ret}\n"
          else
              body = "#{name}_(#{rarg}#{larg});"
	      ret  = nil; retx = nil
          end
          print "  #{body}\n"

          args.each {|a|
	      if(lval.key?(a)) then
  	       case vary[a]
                when "integer"
	          letx = "MC_GetInt(C#{a},V#{a});"
                when "real"
	          letx = "MC_GetFloat(C#{a},V#{a});"
                when "real*8"
	          letx = "MC_GetDouble(C#{a},V#{a});"
                when "character"
	          letx = "MC_GetString(C#{a},V#{a});"
                when "logical"
	          letx = "MC_GetLogic(C#{a},V#{a});"
                else
                  letx = nil
                end
	        print "  #{letx}\n" if letx
              end
          }
	  if(retx) then
	    print "  return #{retx};\n"
          else
	    print "  return Qnil;\n"
	  end
	  print "}\n\n";
       end
#
       if (lnew=~/^ *end *$/) then typ=nil; next; end
#
#      new entry
#
       if    (l.sub!(/^(subroutine)/,'')) 
          typ=$1; ftyp=$1
       elsif \
(l.sub!(/^(((integer|real|logical|character)(\*\d+)?)?)(function)/,''))
          typ=$5; ftyp=$1
       else 
          l.sub!(/^(entry)/,''); typ=$1
       end
       arg=nil
       l =~ /([^(]*)(\((.*)\))?/; name=$1; arg=$3
       if(arg) 
          args = arg.split(/,/)
       else 
          args = []
       end
       vary={} if (typ == 'subroutine' || typ == /function/) 
       lval={}
##     DENNOU SPECIFIC    
       if (l =~ /..(i|r|l|c|p)get *\([^,]*, *(.*) *\)/)
	  ll = $2; 
          lval[ll] = true;
       end
##
       next
    end
    if (l.sub!(/^((integer|real|logical|character)(\*\d+)?)/,""))
	ty=$1; 
        l.gsub!(/(\*\(\*\)|\*\d+)/,"")
        l.gsub!(/\([^)]*\)/,"*")
        vars = l.split(/,/)
	vars.each {|v|
            if(v.sub!(/\*/,"")) then vary[v]=ty + '*'
            else                     vary[v]=ty
	    end
        }
    end
    if (l =~/(.*)=/)
	ll = $1
        ll.gsub!(/\([^)]*\)/,"")
        lval[ll] = true
    end
#   DENNOU SPECIFIC    
    if (l =~/call *...get *\([^,]*, *(.*) *\)/)
	ll = $1; 
        lval[ll] = true
    end
end

print <<'EOQ'
Init_mcdcl()
{
   VALUE mDcl = rb_define_module("Dcl");

EOQ

defs.each {|a| 
print  "   rb_define_module_function(mDcl, \"#{a}\", dcl_#{a}, #{argn[a]});\n"
}

print <<'EOQ'
}

/* I don't know why this is neccessary */
MAIN__()
{
}
EOQ



